<template>
  <div class="container">
    <div class="col-md-8 mx-auto form">
      <FormCita
        @show-hours="displayhours"
        :hairdressers="hairdressers"
        :service="service"
      />
      <Houres
        :freeHours="freeHours"
        :endHours="endHours"
        @save-hours-event="saveHours"
        @save-endtime-event="saveendtime"
        v-if="show"
      />




      <div class="form-group">
        <button
          type="button"
          @click="sendResvationData"
          v-if="visibleButtone"
          class="btn btn-secondary"
        >
          Enviar
        </button>
      </div>

    
     
    </div>
  </div>
</template>
<script>
import FormCita from "@/components/Form/FormCita.vue";
import Houres from "@/components/Form/Houres.vue";
import api from "@/api.js";
export default {
  components: {
    FormCita,
    Houres,
  },

  data() {
    return {
      service: [],
      hairdressers: [],
      freeHours: [],
      endHours: [],
      dsateresrvacion:[],
      show: false,
      reservation: {
        id_reservation: "",
        id_user: "",
        day_week: "1",
        datee: "",
        timee: "",
        id_hairdressers: "",
        id_service: "",
        end_time: "",
      },
      visibleButtone: false,
    
    };
  },

  async mounted() {
    this.service = await this.displayservice();
    this.hairdressers = await this.displayhairdressers();
    this.dsateresrvacion= await this.dateresrvatin()
    this.reservation.id_user = this.$route.params.idActualUser;
    this.visibleButtone = false;
    //  let d = new Date();
    // n = d.getDay();
    // this.reservation.day_week = n;
  },

  methods: {
    async displayservice() {
      return await api.displayServices();
    },

    async displayhairdressers() {
      return await api.displayHairdressers();
    },
async dateresrvatin(){
    return await   api.displaydateReservation(this.$route.params.idActualUser);

  },
    saveTime(timee) {
      this.reservation.timee = timee;
    },
    saveend_time(end_time) {
      this.reservation.end_time = end_time;
    },
    saveendtime(end_time) {
      this.saveend_time(end_time);
      this.visibleButtone = true;
    },

    saveId(id_hairdressers, datee, id_service) {
      this.reservation.id_hairdressers = id_hairdressers;
      this.reservation.datee = datee;
      this.reservation.id_service = id_service;
    },

    async saveHours(timee) {
      this.saveTime(timee);
      if (this.reservation.id_service === "1") {
        this.endHours = await api.reservationendtimecuthair(
          this.reservation.id_hairdressers,
          this.reservation.datee,
          timee
        );
      } else if (this.reservation.id_service === "2") {
        this.endHours = await api.reservationendtimecutbeard(
          this.reservation.id_hairdressers,
          this.reservation.datee,
          timee
        );
      } else if (this.reservation.id_service === "3") {
        this.endHours = await api.reservationendtimecuthairandbeard(
          this.reservation.id_hairdressers,
          this.reservation.datee,
          timee
        );
      }
    },

    async displayhours(id_hairdressers, datee, id_service) {
      this.saveId(id_hairdressers, datee, id_service);
      if (id_service === "1") {
        this.freeHours = await api.displayHourstocuthair(
          id_hairdressers,
          datee
        );
        this.show = true;
      } else if (id_service === "2") {
        this.freeHours = await api.displayHourscutbeard(id_hairdressers, datee);
        this.show = true;
      } else if (id_service === "3") {
        this.freeHours = await api.displayHourscutbeardandhair(
          id_hairdressers,
          datee
        );
        this.show = true;
      }
    },
  
    async sendResvationData() {
      // var d = new Date();
      //  var n = d.getDay();
      //  this.reservation.day_week = n;
   
         
     
   
      if (this.reservation.datee === this.dsateresrvacion[0].datee ) {
          
        alert("tienes cita la misma fecha " +this.dsateresrvacion[0].datee+ " lo siento");
      } else {
        this.reservation.id_user = this.$route.params.idActualUser;
        console.log(this.reservation);
        api.sendResvation(this.reservation);
        this.$router.push("/Reservation/" + this.$route.params.idActualUser);
    }
    },
  },
};
</script>
